'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _HttpClient = require('./helpers/HttpClient');

var _HttpClient2 = _interopRequireDefault(_HttpClient);

var _Record = require('./Entity/Record');

var _Record2 = _interopRequireDefault(_Record);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require("babel-polyfill");

var AprApi = function () {
    function AprApi() {
        _classCallCheck(this, AprApi);
    }

    _createClass(AprApi, [{
        key: 'getByRegistrationNumber',
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(regNo) {
                var data;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                if (!/^\d+$/.exec(regNo.toString())) {
                                    reject("Registration number must be numeric");
                                }
                                _context.next = 3;
                                return _HttpClient2.default.searchByRegistrationNumber(regNo);

                            case 3:
                                data = _context.sent;
                                return _context.abrupt('return', new _Record2.default(data));

                            case 5:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function getByRegistrationNumber(_x) {
                return _ref.apply(this, arguments);
            }

            return getByRegistrationNumber;
        }()
    }]);

    return AprApi;
}();

exports.default = new AprApi();